Page MenuHomePhabricator

Implement a namespace in mediawiki.org to host the developer hub
Closed, DeclinedPublic

Description

According the the current plan (see T312), the developer hub will be located in a namespace at mediawiki.org. We need to decide which one.

Options:

  • A new one e.g. Dev: -- in order to start clean without affecting existing content, that could be moved here as it is being polished.
  • API: -- "The MediaWiki web API is a Web service that provides convenient access to wiki features, data, and meta-data over HTTP."
  • Manual: -- "This is a technical manual for the MediaWiki software. It contains information for developers and system administrators on installing, managing and developing for the MediaWiki software."
  • Help: -- (User documentation)

Details

Reference
fl555
Related Gerrit Patches:
operations/mediawiki-config : masterAdd Dev namespace on mediawiki.org

Related Objects

Event Timeline

flimport raised the priority of this task from to Medium.Sep 12 2014, 1:46 AM
flimport added a project: Web-APIs-Hub.
flimport set Reference to fl555.

legoktm wrote on 2014-08-26 17:52:35 (UTC)

The biggest advantage of the Help namespace is that everything is PD, so anyone can use it with absolutely no restrictions.

I would much prefer using that instead of creating yet another namespace. But namespaces are cheap, and if we choose to go the ContentHandler route, we'll have to use a separate one.

qgil wrote on 2014-08-26 20:05:44 (UTC)

Can we publish API documentation under CC0 when it is extracted from source code files that are surely not CC0?

flimport assigned this task to Qgil.Oct 2 2014, 9:46 PM
Qgil removed Qgil as the assignee of this task.Oct 11 2014, 6:27 PM
Qgil lowered the priority of this task from Medium to Low.Oct 22 2014, 6:20 PM
In T369#4129, @Legoktm wrote:

The biggest advantage of the Help namespace is that everything is PD, so anyone can use it with absolutely no restrictions.
I would much prefer using that instead of creating yet another namespace. But namespaces are cheap, and if we choose to go the ContentHandler route, we'll have to use a separate one.

I'd rather keep the scope of this namespace to developer documentation. Mixing Help namespace will get messy. If we want to use CC0 for this, we can always do it.

gerritbot added a subscriber: gerritbot.

Change 187278 had a related patch set uploaded (by Spage):
Add Dev namespace on mediawiki.org

https://gerrit.wikimedia.org/r/187278

Patch-For-Review

Change 187278 had a related patch set uploaded (by Spage):
Add Dev namespace on mediawiki.org
https://gerrit.wikimedia.org/r/187278

That adds "Dev" namespace and "Dev_talk". That namespace will provide a place for pages making up a "hub for developers and researchers interested in Wikimedia data and the APIs to interact with it."

We could also use namespaces to:

  • Use a different skin so we can have more pleasing pages in this area.
  • Hold additional kinds of developer documentation (writing extensions, MW architecture, etc.)
  • Hold static pages generated from source code
    • such pages would have the license of the source code (mostly GPL, also MIT for VE, etc.) rather than mw.org's CC-BY-SA license.
  • Identify related set of pages to search in Special:Search.

but let's take it one step at a time ;)

In T369#999176, @Qgil wrote:

I'd rather keep the scope of this namespace to developer documentation. Mixing Help namespace will get messy. If we want to use CC0 for this, we can always do it.

Developer documentation is already in the Manual: namespace then.

Qgil updated the task description. (Show Details)Jan 29 2015, 12:45 AM
Qgil added a comment.Jan 29 2015, 12:56 AM

The primary audience of this namespace are developers and researchers interested in Wikimedia data and the APIs to interact with it. Manual: is "a technical manual for the MediaWiki software. It contains information for developers and system administrators on installing, managing and developing for the MediaWiki software." A different thing.

API: probably has more overlapping content, but it is better to start with a new namespace. I think it is very important to have the new developer hub in mediawiki.org, but I also think it is very important to start with a clean house. A Dev: namespace provides this possibility. We can create new content there (starting with a landing page) and we can move good docs in other parts of mediawiki.org as soon as they are polished.

Qgil added a comment.Feb 9 2015, 9:50 AM
In T303#1013941, @Qgil wrote:

@Spage is focusing on prototyping through the creation of actual content in mediawiki.org, under the API: namespace. From there we can decide what's next.

Qgil updated the task description. (Show Details)Mar 17 2015, 10:11 AM
In T369#1000085, @Spage wrote:

That adds "Dev" namespace and "Dev_talk". That namespace will provide a place for pages making up a "hub for developers and researchers interested in Wikimedia data and the APIs to interact with it."

"Dev" it is, then?

Being a new namespace, I wonder whether we need to go through a mediawiki.org community review process. In any case, in order to achieve T101441 we need to have consensus, say by ECT-July-2015.

Weird thing. If it's not developer documentation, then it's for main namespace; if main namespace suddenly became unsuitable for this sort of stuff, we have a problem.

On the other hand, it's fine to have yet another namespace, just because it's easy to eventually kill it.

Qgil added a comment.Jun 15 2015, 8:52 AM

The majority of the Main namespace contains information that is not relevant for developers willing to develop their own applications using Wikimedia APIs and data. This is why we want that documentation in a specific namespace. What you call "kill it" could be read as "migrate it" somewhere else if staying mediawiki.org doesn't make sense down the road. Keeping a door open for that potential scenario works for me as well.

Spage renamed this task from Decide a namespace in mediawiki.org to host the developer hub to Implement a namespace in mediawiki.org to host the developer hub.Jun 22 2015, 6:42 PM

Another reason to have a separate namespace is so Flow can be enabled by default on dev_talk pages. Third-party developers using our data and APIs shouldn't have to learn wikitext to discuss them. I'll modify the patch.

Another reason to have a separate namespace is so Flow can be enabled by default on dev_talk pages.

Is there consensus for this somewhere on mediawiki.org? https://www.mediawiki.org/wiki/Project:Current_issues is the default place where to have such discussions.

Qgil added a comment.Jun 24 2015, 8:38 PM

@Nemo_bis, this is a good point. In T101441 we have mentioned that consensus with the mediawiki.org is a dependency, but we haven't got into the details yet. As soon as T307: Announcing the Developer Hub prototype release is completed we will start working on the steps to discuss and eventually obtain that consensus.

Another reason to have a separate namespace is so Flow can be enabled by default on dev_talk pages.

Is there consensus for this somewhere on mediawiki.org? https://www.mediawiki.org/wiki/Project:Current_issues is the default place where to have such discussions.

I created a Adding a dev namespace for "Data and developer hub" articles topic (linked to this bug) for discussion and a "heads up" about a dev: namespace.

The reason to use Flow on the articles' talk pages is pretty clear: the audience for them (third-party developers whom we want to encourage to use Wikimedia data and APIs) are not MediaWiki hackers or even wiki editors. So wikitext talk pages are an unexpected huge barrier to participation. It's the same rationale for using Flow on talk pages of Beta Features (here, here, and elsewhere), Content translation, and Phabricator/Help; we want to solicit feedback and encourage discussion from an audience beyond expert wikipedians.

Nemo_bis removed a subscriber: Nemo_bis.Jun 25 2015, 9:28 AM
Qgil changed the task status from Open to Stalled.Jun 27 2015, 5:09 PM

Hi, we are moving the discussion about the namespace to https://www.mediawiki.org/wiki/Project:Current_issues#Adding_a_dev_namespace_for_.22Data_and_developer_hub.22_articles_58129

I'm leaving this task open but Stalled until we find consensus there.

Qgil added a comment.Jul 6 2015, 4:00 PM

I have just proposed to NOT create a new Dev: namespace and to improve the existing Api: namespace instead. Your feedback is welcome in the thread at mediawiki.org.

Qgil assigned this task to Spage.Jul 7 2015, 6:02 PM
Spage closed this task as Declined.Jul 8 2015, 8:54 AM

I already authored new articles in the API: namespace on mw.org. To present with a different appearance we can deploy the SkinPerPage extension and have the articles' {{Dev-Article}} tag output <skin>blueprint</skin>. So that's one less reason to have a dedicated namespace,. The other arguments aren't that compelling:

  • "Identify related set of pages to search in Special:Search" is advanced and not useful until we have so much content we need to segregate it in searches
  • the other ideas in T369#1000085 have yet to materialize.
  • another reason was restricting editing, but that was more a concern for T93610: Put WikimediaUI Style Guide on mediawiki.org
Rical added a subscriber: Rical.Jul 10 2015, 10:29 AM

Change 187278 abandoned by Alex Monk:
Add Dev namespace on mediawiki.org

Reason:
Task declined.

https://gerrit.wikimedia.org/r/187278

Rical removed a subscriber: Rical.Jul 21 2017, 9:41 AM